## luajit 2.1.0+openresty20240314

=== debian/changelog ===
luajit (2.1.0+openresty20240314-1) unstable; urgency=medium

  * New upstream version 2.1.0+openresty20240314

 -- Ondřej Surý <ondrej@debian.org>  Mon, 03 Jun 2024 09:32:49 +0200

luajit (2.1.0+openresty20231117-2) unstable; urgency=low

  * Upload to unstable

 -- Ondřej Surý <ondrej@debian.org>  Tue, 27 Feb 2024 22:37:39 +0100

luajit (2.1.0+openresty20231117-1) experimental; urgency=low

  * New upstream version 2.1.0+openresty20231117
  * Switch upstream version to OpenResty upstream to allow
    merging src:luajit2 back to src:luajit.  Debian doesn't
    really need two competing luajit packages.

 -- Ondřej Surý <ondrej@debian.org>  Tue, 27 Feb 2024 22:37:39 +0100

luajit (2.1-20231006-1) unstable; urgency=medium

  * New upstream version 2.1-20231006

 -- Mo Zhou <lumin@debian.org>  Tue, 31 Oct 2023 21:22:31 -0400

luajit2 (2.1-20230410-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository.
  * Update standards version to 4.6.2, no changes needed.

  [ Mo Zhou ]
  * New upstream version 2.1-20230410

 -- Mo Zhou <lumin@debian.org>  Sat, 17 Jun 2023 18:26:28 -0700

luajit2 (2.1-20230119-1) unstable; urgency=medium

  * New upstream version 2.1-20230119 (Closes: #1029433)

 -- Mo Zhou <lumin@debian.org>  Wed, 01 Feb 2023 13:39:03 -0500

luajit2 (2.1-20220915-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Use canonical URL in Vcs-Browser.
  * Update standards version to 4.6.1, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 09 Dec 2022 10:05:14 +0000

luajit2 (2.1-20220915-1) unstable; urgency=medium

  * New upstream version 2.1-20220915
  * Refresh existing patches.
  * Remove unnecessary shlibs:Depends from -common/-dev packages.

 -- Mo Zhou <lumin@debian.org>  Sat, 29 Oct 2022 11:41:29 -0400

luajit2 (2.1-20220411-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add powerpc to Architecture (Closes: #1020508)

 -- Christian Marillat <marillat@debian.org>  Mon, 03 Oct 2022 10:33:21 +0200

luajit2 (2.1-20220411-5.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Mo Zhou ]
  * No longer build on ppc64el.

 -- Paul Gevers <elbrus@debian.org>  Sat, 03 Sep 2022 13:17:37 +0200

luajit2 (2.1-20220411-5) unstable; urgency=medium

  * No Conflicts+Replaces against src:luajit on IBM Architectures.
    It yields transitional dummy packages on these archs, which depends
    on the real binary packages provided by src:luajit2.

 -- Mo Zhou <lumin@debian.org>  Wed, 08 Jun 2022 06:57:03 -0700

luajit2 (2.1-20220411-4) unstable; urgency=medium

  * Update dependency template as libluajit2-5.1-2 | libluajit-5.1-2.
    This is an advanced feature, see deb-symbols(5). Packages built against
    src:luajit2 instead of src:luajit indicates a clear mainatiner preference.
    And hence the dependency template has reversed order compared to that
    of src:luajit, i.e., libluajit-5.1-2 | libluajit2-5.1-2.

 -- Mo Zhou <lumin@debian.org>  Mon, 06 Jun 2022 19:56:18 -0700

luajit2 (2.1-20220411-3) unstable; urgency=medium

  * Fixup missing autopkgtest dependency.

 -- Mo Zhou <lumin@debian.org>  Sat, 04 Jun 2022 22:19:48 -0700

luajit2 (2.1-20220411-2) unstable; urgency=medium

  * Allow using libluajit-5.1-2 as dependency fallback.
    This is a dependency-template feature, see deb-symbols(5) for details.
  * Override lintian warnings about the binary package name.

 -- Mo Zhou <lumin@debian.org>  Sat, 04 Jun 2022 22:12:04 -0700

luajit2 (2.1-20220411-1) unstable; urgency=medium

  * Refresh symbols again for the rest architectures.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Jun 2022 08:27:04 -0700

luajit2 (2.1-20220411-1~exp2) experimental; urgency=medium

  [ Frédéric Bonnard ]
  * Improve symbols file

 -- Mo Zhou <lumin@debian.org>  Wed, 01 Jun 2022 20:40:09 -0700

luajit2 (2.1-20220411-1~exp1) experimental; urgency=medium

  * New upstream version 2.1-20220411. (Closes: #1011320)
  * Borrowed bits from Debian's src:luajit packaging.
  * This package provides the same contents as src:luajit.

 -- Mo Zhou <lumin@debian.org>  Fri, 20 May 2022 10:24:40 -0400

=== debian/control ===
Source: luajit
Section: interpreters
Homepage: https://github.com/openresty/luajit2
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/lua-team/luajit.git
Vcs-Browser: https://salsa.debian.org/lua-team/luajit
Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>,
	   Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13)

Package: luajit
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: libluajit-5.1-2 (= ${binary:Version}),
         libluajit-5.1-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: luajit2
Replaces: luajit2
Description: OpenResty-maintained branch of LuaJIT (interpreter)
 LuaJIT implements the full set of language features defined by Lua 5.1. The
 virtual machine (VM) is API- and ABI-compatible to the standard Lua interpreter
 and can be deployed as a drop-in replacement.
 .
 This package contains the standalone interpreter/jitter that can be used
 as a replacement for the standard lua5.1 interpreter.

Package: libluajit-5.1-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Conflicts: libluajit2-5.1-common
Replaces: libluajit2-5.1-common
Description: OpenResty-maintained branch of LuaJIT (common files)
 This package contains files needed by the LuaJIT interpreter/jitter as well
 by its embeddable (i.e. library) version.

Package: libluajit-5.1-2
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libluajit-5.1-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libluajit2-5.1-2
Replaces: libluajit2-5.1-2
Provides: libluajit-5.1.so.2
Description: OpenResty-maintained branch of LuaJIT (shared objects)
 LuaJIT implements the full set of language features defined by Lua 5.1. The
 virtual machine (VM) is API- and ABI-compatible to the standard Lua interpreter
 and can be deployed as a drop-in replacement.
 .
 This package contains an embeddable version of LuaJIT that can be used as a
 replacement of the standard liblua-5.1 shared library.

Package: libluajit-5.1-dev
Section: libdevel
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc
Depends: libluajit-5.1-2 (= ${binary:Version}),
         ${misc:Depends},
Conflicts: libluajit2-5.1-dev
Replaces: libluajit2-5.1-dev
Provides: libluajit-5.1.so
Description: OpenResty-maintained branch of LuaJIT (development files)
 This package contains header files and a statically linkable library for
 LuaJIT.

## luajit 2.1.0+openresty20240626

=== debian/changelog ===
luajit (2.1.0+openresty20240626-1) unstable; urgency=medium

  * New upstream version 2.1.0+openresty20240626
  * Update symbols file

 -- Ondřej Surý <ondrej@debian.org>  Fri, 05 Jul 2024 13:55:27 +0200

## luajit 2.1.0+openresty20240815

=== src/Makefile ===
##############################################################################
# LuaJIT Makefile. Requires GNU Make.
#
# Please read doc/install.html before changing any variables!
#
# Suitable for POSIX platforms (Linux, *BSD, OSX etc.).
# Also works with MinGW and Cygwin on Windows.
# Please check msvcbuild.bat for building with MSVC on Windows.
#
# Copyright (C) 2005-2023 Mike Pall. See Copyright Notice in luajit.h
##############################################################################

MAJVER=  2
MINVER=  1
ABIVER=  5.1
NODOTABIVER= 51

##############################################################################
#############################  COMPILER OPTIONS  #############################
##############################################################################
# These options mainly affect the speed of the JIT compiler itself, not the
# speed of the JIT-compiled code. Turn any of the optional settings on by
# removing the '#' in front of them. Make sure you force a full recompile
# with "make clean", followed by "make" if you change any options.
#
DEFAULT_CC = gcc
#
# LuaJIT builds as a native 32 or 64 bit binary by default.
CC= $(DEFAULT_CC)
#
# Use this if you want to force a 32 bit build on a 64 bit multilib OS.
#CC= $(DEFAULT_CC) -m32
#
# Since the assembler part does NOT maintain a frame pointer, it's pointless
# to slow down the C part by not omitting it. Debugging, tracebacks and
# unwinding are not affected -- the assembler part has frame unwind
# information and GCC emits it where needed (x64) or with -g (see CCDEBUG).
CCOPT= -O2 -fomit-frame-pointer
# Use this if you want to generate a smaller binary (but it's slower):
#CCOPT= -Os -fomit-frame-pointer
# Note: it's no longer recommended to use -O3 with GCC 4.x.
# The I-Cache bloat usually outweighs the benefits from aggressive inlining.
#
# Target-specific compiler options:
#
# x86/x64 only: For GCC 4.2 or higher and if you don't intend to distribute
# the binaries to a different machine you could also use: -march=native
#
CCOPT_x86= -march=i686 -msse -msse2 -mfpmath=sse
CCOPT_x64=
CCOPT_arm=
CCOPT_arm64=
CCOPT_ppc=
CCOPT_mips=
#
#CCDEBUG=
# Uncomment the next line to generate debug information:
CCDEBUG= -g
#
CCWARN= -Wall
# Uncomment the next line to enable more warnings:
#CCWARN+= -Wextra -Wdeclaration-after-statement -Wredundant-decls -Wshadow -Wpointer-arith
#
##############################################################################

##############################################################################
################################  BUILD MODE  ################################
##############################################################################
# The default build mode is mixed mode on POSIX. On Windows this is the same
# as dynamic mode.
#
# Mixed mode creates a static + dynamic library and a statically linked luajit.
BUILDMODE= mixed
#
# Static mode creates a static library and a statically linked luajit.
#BUILDMODE= static
#
# Dynamic mode creates a dynamic library and a dynamically linked luajit.
# Note: this executable will only run when the library is installed!
#BUILDMODE= dynamic
#
##############################################################################

##############################################################################
#################################  FEATURES  #################################
##############################################################################
# Enable/disable these features as needed, but make sure you force a full
# recompile with "make clean", followed by "make".
XCFLAGS=
#
# Permanently disable the FFI extension to reduce the size of the LuaJIT
# executable. But please consider that the FFI library is compiled-in,
# but NOT loaded by default. It only allocates any memory, if you actually
# make use of it.
#XCFLAGS+= -DLUAJIT_DISABLE_FFI
#
# Features from Lua 5.2 that are unlikely to break existing code are
# enabled by default. Some other features that *might* break some existing
# code (e.g. __pairs or os.execute() return values) can be enabled here.
# Note: this does not provide full compatibility with Lua 5.2 at this time.
#XCFLAGS+= -DLUAJIT_ENABLE_LUA52COMPAT
#
# Disable the JIT compiler, i.e. turn LuaJIT into a pure interpreter.
#XCFLAGS+= -DLUAJIT_DISABLE_JIT
#
# Some architectures (e.g. PPC) can use either single-number (1) or
# dual-number (2) mode. Uncomment one of these lines to override the
# default mode. Please see LJ_ARCH_NUMMODE in lj_arch.h for details.
#XCFLAGS+= -DLUAJIT_NUMMODE=1
#XCFLAGS+= -DLUAJIT_NUMMODE=2
#
# Disable LJ_GC64 mode for x64.
#XCFLAGS+= -DLUAJIT_DISABLE_GC64
#
##############################################################################

##############################################################################
############################  DEBUGGING SUPPORT  #############################
##############################################################################
# Enable these options as needed, but make sure you force a full recompile
# with "make clean", followed by "make".
# Note that most of these are NOT suitable for benchmarking or release mode!
#
# Use the system provided memory allocator (realloc) instead of the
# bundled memory allocator. This is slower, but sometimes helpful for
# debugging. This option cannot be enabled on x64 without GC64, since
# realloc usually doesn't return addresses in the right address range.
# OTOH this option is mandatory for Valgrind's memcheck tool on x64 and
# the only way to get useful results from it for all other architectures.
#XCFLAGS+= -DLUAJIT_USE_SYSMALLOC
#
# This define is required to run LuaJIT under Valgrind. The Valgrind
# header files must be installed. You should enable debug information, too.
#XCFLAGS+= -DLUAJIT_USE_VALGRIND
#
# This is the client for the GDB JIT API. GDB 7.0 or higher is required
# to make use of it. See lj_gdbjit.c for details. Enabling this causes
# a non-negligible overhead, even when not running under GDB.
#XCFLAGS+= -DLUAJIT_USE_GDBJIT
#
# Turn on assertions for the Lua/C API to debug problems with lua_* calls.
# This is rather slow -- use only while developing C libraries/embeddings.
#XCFLAGS+= -DLUA_USE_APICHECK
#
# Turn on assertions for the whole LuaJIT VM. This significantly slows down
# everything. Use only if you suspect a problem with LuaJIT itself.
#XCFLAGS+= -DLUA_USE_ASSERT
#
##############################################################################
# You probably don't need to change anything below this line!
##############################################################################

##############################################################################
# Host system detection.
##############################################################################

ifeq (Windows,$(findstring Windows,$(OS))$(MSYSTEM)$(TERM))
  HOST_SYS= Windows
else
  HOST_SYS:= $(shell uname -s)
  ifneq (,$(findstring MINGW,$(HOST_SYS)))
    HOST_SYS= Windows
    HOST_MSYS= mingw
  endif
  ifneq (,$(findstring MSYS,$(HOST_SYS)))
    HOST_SYS= Windows
    HOST_MSYS= mingw
  endif
  ifneq (,$(findstring CYGWIN,$(HOST_SYS)))
    HOST_SYS= Windows
    HOST_MSYS= cygwin
  endif
endif

##############################################################################
# Flags and options for host and target.
##############################################################################

# You can override the following variables at the make command line:
#   CC       HOST_CC       STATIC_CC       DYNAMIC_CC
#   CFLAGS   HOST_CFLAGS   TARGET_CFLAGS
#   LDFLAGS  HOST_LDFLAGS  TARGET_LDFLAGS  TARGET_SHLDFLAGS
#   LIBS     HOST_LIBS     TARGET_LIBS
#   CROSS    HOST_SYS      TARGET_SYS      TARGET_FLAGS
#
# Cross-compilation examples:
#   make HOST_CC="gcc -m32" CROSS=i586-mingw32msvc- TARGET_SYS=Windows
#   make HOST_CC="gcc -m32" CROSS=powerpc-linux-gnu-

ASOPTIONS= $(CCOPT) $(CCWARN) $(XCFLAGS) $(CFLAGS)
CCOPTIONS= $(CCDEBUG) $(ASOPTIONS)
LDOPTIONS= $(CCDEBUG) $(LDFLAGS)

HOST_CC= $(CC)
HOST_RM?= rm -f
# If left blank, minilua is built and used. You can supply an installed
# copy of (plain) Lua 5.1 or 5.2, plus Lua BitOp. E.g. with: HOST_LUA=lua
HOST_LUA=

HOST_XCFLAGS= -I.
HOST_XLDFLAGS=
HOST_XLIBS=
HOST_ACFLAGS= $(CCOPTIONS) $(HOST_XCFLAGS) $(TARGET_ARCH) $(HOST_CFLAGS)
HOST_ALDFLAGS= $(LDOPTIONS) $(HOST_XLDFLAGS) $(HOST_LDFLAGS)
HOST_ALIBS= $(HOST_XLIBS) $(LIBS) $(HOST_LIBS)

STATIC_CC = $(CROSS)$(CC)
DYNAMIC_CC = $(CROSS)$(CC) -fPIC
TARGET_CC= $(STATIC_CC)
TARGET_STCC= $(STATIC_CC)
TARGET_DYNCC= $(DYNAMIC_CC)
TARGET_LD= $(CROSS)$(CC)
TARGET_AR= $(CROSS)ar rcus
TARGET_STRIP= $(CROSS)strip

TARGET_LIBPATH= $(or $(PREFIX),/usr/local)/$(or $(MULTILIB),lib)
TARGET_SONAME= libluajit-$(ABIVER).so.$(MAJVER)
TARGET_DYLIBNAME= libluajit-$(ABIVER).$(MAJVER).dylib
TARGET_DYLIBPATH= $(TARGET_LIBPATH)/$(TARGET_DYLIBNAME)
TARGET_DLLNAME= lua$(NODOTABIVER).dll
TARGET_DLLDOTANAME= libluajit-$(ABIVER).dll.a
TARGET_XSHLDFLAGS= -shared -fPIC -Wl,-soname,$(TARGET_SONAME)
TARGET_DYNXLDOPTS=

TARGET_LFSFLAGS= -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
TARGET_XCFLAGS= $(TARGET_LFSFLAGS) -U_FORTIFY_SOURCE
TARGET_XLDFLAGS=
TARGET_XLIBS= -lm
TARGET_TCFLAGS= $(CCOPTIONS) $(TARGET_XCFLAGS) $(TARGET_FLAGS) $(TARGET_CFLAGS)
TARGET_ACFLAGS= $(CCOPTIONS) $(TARGET_XCFLAGS) $(TARGET_FLAGS) $(TARGET_CFLAGS)
TARGET_ASFLAGS= $(ASOPTIONS) $(TARGET_XCFLAGS) $(TARGET_FLAGS) $(TARGET_CFLAGS)
TARGET_ALDFLAGS= $(LDOPTIONS) $(TARGET_XLDFLAGS) $(TARGET_FLAGS) $(TARGET_LDFLAGS)
TARGET_ASHLDFLAGS= $(LDOPTIONS) $(TARGET_XSHLDFLAGS) $(TARGET_FLAGS) $(TARGET_SHLDFLAGS)
TARGET_ALIBS= $(TARGET_XLIBS) $(LIBS) $(TARGET_LIBS)

TARGET_TESTARCH:=$(shell $(TARGET_CC) $(TARGET_TCFLAGS) -E lj_arch.h -dM)
ifneq (,$(findstring LJ_TARGET_X64 ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= x64
else
ifneq (,$(findstring LJ_TARGET_X86 ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= x86
else
ifneq (,$(findstring LJ_TARGET_ARM ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= arm
else
ifneq (,$(findstring LJ_TARGET_S390X ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= s390x
else
ifneq (,$(findstring LJ_TARGET_ARM64 ,$(TARGET_TESTARCH)))
  ifneq (,$(findstring __AARCH64EB__ ,$(TARGET_TESTARCH)))
    TARGET_ARCH= -D__AARCH64EB__=1
  endif
  TARGET_LJARCH= arm64
else
ifneq (,$(findstring LJ_TARGET_PPC ,$(TARGET_TESTARCH)))
  ifneq (,$(findstring LJ_LE 1,$(TARGET_TESTARCH)))
    TARGET_ARCH= -DLJ_ARCH_ENDIAN=LUAJIT_LE
  else
    TARGET_ARCH= -DLJ_ARCH_ENDIAN=LUAJIT_BE
  endif
  TARGET_LJARCH= ppc
else
ifneq (,$(findstring LJ_TARGET_MIPS ,$(TARGET_TESTARCH)))
  ifneq (,$(findstring MIPSEL ,$(TARGET_TESTARCH)))
    TARGET_ARCH= -D__MIPSEL__=1
  endif
  ifneq (,$(findstring LJ_TARGET_MIPS64 ,$(TARGET_TESTARCH)))
    TARGET_LJARCH= mips64
  else
    TARGET_LJARCH= mips
  endif
else
  $(error Unsupported target architecture)
endif
endif
endif
endif
endif
endif
endif

ifneq (,$(findstring LJ_TARGET_PS3 1,$(TARGET_TESTARCH)))
  TARGET_SYS= PS3
  TARGET_ARCH+= -D__CELLOS_LV2__
  TARGET_XCFLAGS+= -DLUAJIT_USE_SYSMALLOC
  TARGET_XLIBS+= -lpthread
endif

TARGET_XCFLAGS+= $(CCOPT_$(TARGET_LJARCH))
TARGET_ARCH+= $(patsubst %,-DLUAJIT_TARGET=LUAJIT_ARCH_%,$(TARGET_LJARCH))

ifneq (,$(PREFIX))
ifneq (/usr/local,$(PREFIX))
  TARGET_XCFLAGS+= -DLUA_ROOT=\"$(PREFIX)\"
  ifneq (/usr,$(PREFIX))
    TARGET_DYNXLDOPTS= -Wl,-rpath,$(TARGET_LIBPATH)
  endif
endif
endif
ifneq (,$(MULTILIB))
  TARGET_XCFLAGS+= -DLUA_MULTILIB=\"$(MULTILIB)\"
endif
ifneq (,$(LMULTILIB))
  TARGET_XCFLAGS+= -DLUA_LMULTILIB=\"$(LMULTILIB)\"
endif
ifneq (,$(INSTALL_LJLIBD))
  TARGET_XCFLAGS+= -DLUA_LJDIR=\"$(INSTALL_LJLIBD)\"
endif

##############################################################################
# Target system detection.
##############################################################################

TARGET_SYS?= $(HOST_SYS)
ifeq (Windows,$(TARGET_SYS))
  TARGET_STRIP+= --strip-unneeded
  TARGET_XSHLDFLAGS= -shared -Wl,--out-implib,$(TARGET_DLLDOTANAME)
  TARGET_DYNXLDOPTS=
else
  TARGET_AR+= 2>/dev/null

=== debian/changelog ===
luajit (2.1.0+openresty20240815-1) unstable; urgency=medium

  * New upstream version 2.1.0+openresty20240815

 -- Ondřej Surý <ondrej@debian.org>  Sun, 18 Aug 2024 23:22:02 +0200

## luajit 2.1.0+openresty20241113

=== Makefile ===
##############################################################################
# LuaJIT top level Makefile for installation. Requires GNU Make.
#
# Please read doc/install.html before changing any variables!
#
# Suitable for POSIX platforms (Linux, *BSD, OSX etc.).
# Note: src/Makefile has many more configurable options.
#
# ##### This Makefile is NOT useful for Windows! #####
# For MSVC, please follow the instructions given in src/msvcbuild.bat.
# For MinGW and Cygwin, cd to src and run make with the Makefile there.
#
# Copyright (C) 2005-2023 Mike Pall. See Copyright Notice in luajit.h
##############################################################################

MAJVER=  2
MINVER=  1
ABIVER=  5.1

# LuaJIT uses rolling releases. The release version is based on the time of
# the latest git commit. The 'git' command must be available during the build.
RELVER= $(shell cat src/luajit_relver.txt 2>/dev/null || : )
# Note: setting it with := doesn't work, since it will change during the build.

MMVERSION= $(MAJVER).$(MINVER)
VERSION= $(MMVERSION).$(RELVER)

##############################################################################
#
# Change the installation path as needed. This automatically adjusts
# the paths in src/luaconf.h, too. Note: PREFIX must be an absolute path!
#
export PREFIX= /usr/local
export MULTILIB= lib
##############################################################################

DPREFIX= $(DESTDIR)$(PREFIX)
INSTALL_BIN=   $(DPREFIX)/bin
INSTALL_LIB=   $(DPREFIX)/$(MULTILIB)
INSTALL_SHARE= $(DPREFIX)/share
INSTALL_DEFINC= $(DPREFIX)/include/luajit-$(MMVERSION)
INSTALL_INC=   $(INSTALL_DEFINC)

export INSTALL_LJLIBD= $(INSTALL_SHARE)/luajit-$(MMVERSION)
INSTALL_JITLIB= $(INSTALL_LJLIBD)/jit
INSTALL_LMODD= $(INSTALL_SHARE)/lua
INSTALL_LMOD= $(INSTALL_LMODD)/$(ABIVER)
INSTALL_CMODD= $(INSTALL_LIB)/lua
INSTALL_CMOD= $(INSTALL_CMODD)/$(ABIVER)
INSTALL_MAN= $(INSTALL_SHARE)/man/man1
INSTALL_PKGCONFIG= $(INSTALL_LIB)/pkgconfig

INSTALL_TNAME= luajit-$(VERSION)
INSTALL_TSYMNAME= luajit
INSTALL_ANAME= libluajit-$(ABIVER).a
INSTALL_SOSHORT1= libluajit-$(ABIVER).so
INSTALL_SOSHORT2= libluajit-$(ABIVER).so.$(MAJVER)
INSTALL_SONAME= libluajit-$(ABIVER).so.$(VERSION)
INSTALL_DYLIBSHORT1= libluajit-$(ABIVER).dylib
INSTALL_DYLIBSHORT2= libluajit-$(ABIVER).$(MAJVER).dylib
INSTALL_DYLIBNAME= libluajit-$(ABIVER).$(VERSION).dylib
INSTALL_PCNAME= luajit.pc

INSTALL_STATIC= $(INSTALL_LIB)/$(INSTALL_ANAME)
INSTALL_DYN= $(INSTALL_LIB)/$(INSTALL_SONAME)
INSTALL_SHORT1= $(INSTALL_LIB)/$(INSTALL_SOSHORT1)
INSTALL_SHORT2= $(INSTALL_LIB)/$(INSTALL_SOSHORT2)
INSTALL_T= $(INSTALL_BIN)/$(INSTALL_TNAME)
INSTALL_TSYM= $(INSTALL_BIN)/$(INSTALL_TSYMNAME)
INSTALL_PC= $(INSTALL_PKGCONFIG)/$(INSTALL_PCNAME)

INSTALL_DIRS= $(INSTALL_BIN) $(INSTALL_LIB) $(INSTALL_INC) $(INSTALL_MAN) \
  $(INSTALL_PKGCONFIG) $(INSTALL_JITLIB) $(INSTALL_LMOD) $(INSTALL_CMOD)
UNINSTALL_DIRS= $(INSTALL_JITLIB) $(INSTALL_LJLIBD) $(INSTALL_INC) \
  $(INSTALL_LMOD) $(INSTALL_LMODD) $(INSTALL_CMOD) $(INSTALL_CMODD)

RM= rm -f
MKDIR= mkdir -p
RMDIR= rmdir 2>/dev/null
SYMLINK= ln -sf
INSTALL_X= install -m 0755
INSTALL_F= install -m 0644
UNINSTALL= $(RM)
LDCONFIG= ldconfig -n 2>/dev/null
SED_PC= sed -e "s|^prefix=.*|prefix=$(PREFIX)|" \
	    -e "s|^multilib=.*|multilib=$(MULTILIB)|" \
	    -e "s|^relver=.*|relver=$(RELVER)|"
ifneq ($(INSTALL_DEFINC),$(INSTALL_INC))
  SED_PC+= -e "s|^includedir=.*|includedir=$(INSTALL_INC)|"
endif

FILE_T= luajit
FILE_A= libluajit.a
FILE_SO= libluajit.so
FILE_MAN= luajit.1
FILE_PC= luajit.pc
FILES_INC= lua.h lualib.h lauxlib.h luaconf.h lua.hpp luajit.h
FILES_JITLIB= bc.lua bcsave.lua dump.lua p.lua v.lua zone.lua \
	      dis_x86.lua dis_x64.lua dis_arm.lua dis_arm64.lua \
	      dis_arm64be.lua dis_ppc.lua dis_mips.lua dis_mipsel.lua \
	      dis_mips64.lua dis_mips64el.lua \
	      dis_mips64r6.lua dis_mips64r6el.lua \
	      vmdef.lua

ifeq (,$(findstring Windows,$(OS)))
  HOST_SYS:= $(shell uname -s)
else
  HOST_SYS= Windows
endif
TARGET_SYS?= $(HOST_SYS)

ifeq (Darwin,$(TARGET_SYS))
  INSTALL_SONAME= $(INSTALL_DYLIBNAME)
  INSTALL_SOSHORT1= $(INSTALL_DYLIBSHORT1)
  INSTALL_SOSHORT2= $(INSTALL_DYLIBSHORT2)
  LDCONFIG= :
  SED_PC+= -e "s| -Wl,-E||"
endif

##############################################################################

INSTALL_DEP= src/luajit

default all $(INSTALL_DEP):
	@echo "==== Building LuaJIT $(MMVERSION) ===="
	$(MAKE) -C src
	@echo "==== Successfully built LuaJIT $(MMVERSION) ===="

install: $(INSTALL_DEP)
	@echo "==== Installing LuaJIT $(VERSION) to $(PREFIX) ===="
	$(MKDIR) $(INSTALL_DIRS)
	cd src && $(INSTALL_X) $(FILE_T) $(INSTALL_T)
	cd src && test -f $(FILE_A) && $(INSTALL_F) $(FILE_A) $(INSTALL_STATIC) || :
	$(RM) $(INSTALL_DYN) $(INSTALL_SHORT1) $(INSTALL_SHORT2)
	cd src && test -f $(FILE_SO) && \
	  $(INSTALL_X) $(FILE_SO) $(INSTALL_DYN) && \
	  ( $(LDCONFIG) $(INSTALL_LIB) || : ) && \
	  $(SYMLINK) $(INSTALL_SONAME) $(INSTALL_SHORT1) && \
	  $(SYMLINK) $(INSTALL_SONAME) $(INSTALL_SHORT2) || :
	cd etc && $(INSTALL_F) $(FILE_MAN) $(INSTALL_MAN)
	cd etc && $(SED_PC) $(FILE_PC) > $(FILE_PC).tmp && \
	  $(INSTALL_F) $(FILE_PC).tmp $(INSTALL_PC) && \
	  $(RM) $(FILE_PC).tmp
	cd src && $(INSTALL_F) $(FILES_INC) $(INSTALL_INC)
	cd src/jit && $(INSTALL_F) $(FILES_JITLIB) $(INSTALL_JITLIB)
	$(SYMLINK) $(INSTALL_TNAME) $(INSTALL_TSYM)
	@echo "==== Successfully installed LuaJIT $(VERSION) to $(PREFIX) ===="

uninstall:
	@echo "==== Uninstalling LuaJIT $(VERSION) from $(PREFIX) ===="
	$(UNINSTALL) $(INSTALL_TSYM) $(INSTALL_T) $(INSTALL_STATIC) $(INSTALL_DYN) $(INSTALL_SHORT1) $(INSTALL_SHORT2) $(INSTALL_MAN)/$(FILE_MAN) $(INSTALL_PC)
	for file in $(FILES_JITLIB); do \
	  $(UNINSTALL) $(INSTALL_JITLIB)/$$file; \
	  done
	for file in $(FILES_INC); do \
	  $(UNINSTALL) $(INSTALL_INC)/$$file; \
	  done
	$(LDCONFIG) $(INSTALL_LIB)
	$(RMDIR) $(UNINSTALL_DIRS) || :
	@echo "==== Successfully uninstalled LuaJIT $(VERSION) from $(PREFIX) ===="

##############################################################################

amalg:
	@echo "==== Building LuaJIT $(MMVERSION) (amalgamation) ===="
	$(MAKE) -C src amalg
	@echo "==== Successfully built LuaJIT $(MMVERSION) (amalgamation) ===="

clean:
	$(MAKE) -C src clean

.PHONY: all install amalg clean

##############################################################################

=== debian/changelog ===
luajit (2.1.0+openresty20241113-3) unstable; urgency=medium

  * Release to unstable.

 -- Mo Zhou <lumin@debian.org>  Tue, 07 Jan 2025 20:31:22 -0500

luajit (2.1.0+openresty20241113-2) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Import changes from 2.1.0+openresty20240815-1.1
  * Import changes from 2.1.0+openresty20240815-1.2

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Jan 2025 14:53:59 -0500

luajit (2.1.0+openresty20241113-1) experimental; urgency=medium

  * New upstream version 2.1.0+openresty20241113

 -- Mo Zhou <lumin@debian.org>  Sun, 15 Dec 2024 08:55:11 -0500

luajit (2.1.0+openresty20240815-1.2) unstable; urgency=medium

  * Non-maintainer upload
  * Refresh patches of previous upload to fix riscv64, s390x, loong64
    build failures (Closes: #1087838, 1087833)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 21 Nov 2024 12:54:13 +0100

luajit (2.1.0+openresty20240815-1.1) unstable; urgency=medium

  [ Bo YU <tsu.yubo@gmail.com> ]
  * luajit: Add support for riscv64 (Closes: #1034484)

  [ Xiaolin Zhao <zhaoxiaolin@loongson.cn> ]
  * Add support for LoongArch64 (Closes: #1067890)

  [ Gianfranco Costamagna ]
  * Non-maintainer upload
  * Rebase loongarch64 patch on top of riscv64 one

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Nov 2024 10:07:38 +0100

## luajit 2.1.0+openresty20250117

=== src/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # Also works with MinGW and Cygwin on Windows.
 # Please check msvcbuild.bat for building with MSVC on Windows.
 #
-# Copyright (C) 2005-2023 Mike Pall. See Copyright Notice in luajit.h
+# Copyright (C) 2005-2025 Mike Pall. See Copyright Notice in luajit.h
 ##############################################################################
 
 MAJVER=  2

=== debian/changelog ===
luajit (2.1.0+openresty20250117-2ubuntu1) questing; urgency=medium

  * Use .option norvc for avoiding compressed instructions.
    (LP: #2121590)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 28 Aug 2025 14:03:37 +0200

luajit (2.1.0+openresty20250117-2) unstable; urgency=medium

  * Replace the old package for Build-Depends-Package in symbols file.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 07 Feb 2025 11:19:18 -0500

luajit (2.1.0+openresty20250117-1) experimental; urgency=medium

  * New upstream version 2.1.0+openresty20250117
  * Refresh existing patches.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Wed, 05 Feb 2025 11:32:40 -0500

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,14 @@
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/lua-team/luajit.git
 Vcs-Browser: https://salsa.debian.org/lua-team/luajit
-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>,
 	   Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13)
 
 Package: luajit
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libluajit-5.1-2 (= ${binary:Version}),
@@ -39,7 +40,7 @@
  by its embeddable (i.e. library) version.
 
 Package: libluajit-5.1-2
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libluajit-5.1-common (= ${source:Version}),
@@ -60,7 +61,7 @@
 Section: libdevel
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64
 Depends: libluajit-5.1-2 (= ${binary:Version}),
          ${misc:Depends},
 Conflicts: libluajit2-5.1-dev

=== debian/watch ===
version=4
opts=\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
uversionmangle=s%v?2\.1-%2.1.0+openresty% \
https://github.com/openresty/luajit2/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## luajit 2.1.0+openresty20250826

=== debian/changelog ===
luajit (2.1.0+openresty20250826-0+ppc64.1) unreleased; urgency=medium

  * Also build all package

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 07 Oct 2025 03:41:15 -0700

luajit (2.1.0+openresty20250826-0+ppc64) unreleased; urgency=medium

  [ Yuqian Yang ]
  * Enable package on hurd-i386 hurd-amd64.

  [ John Paul Adrian Glaubitz ]
  * New upstream version 2.1.0+openresty20250826
  * Enable ppc64 and ppc64el in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 07 Oct 2025 03:29:04 -0700

## luajit 2.1.0+openresty20251030

=== debian/changelog ===
luajit (2.1.0+openresty20251030-1~exp2) experimental; urgency=medium

  * Rebuild with merged changes from the git repository.

 -- Ondřej Surý <ondrej@debian.org>  Fri, 19 Dec 2025 15:33:07 +0100

luajit (2.1.0+openresty20251030-1~exp1) experimental; urgency=medium

  * New upstream version 2.1.0+openresty20251030
  * Enable LuaJIT with Lua 5.2 compat (Closes: #781728)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 19 Dec 2025 08:42:02 +0100

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,13 @@
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/lua-team/luajit.git
 Vcs-Browser: https://salsa.debian.org/lua-team/luajit
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>,
 	   Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13)
 
 Package: luajit
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64 hurd-i386 hurd-amd64
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libluajit-5.1-2 (= ${binary:Version}),
@@ -40,7 +39,7 @@
  by its embeddable (i.e. library) version.
 
 Package: libluajit-5.1-2
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64 hurd-i386 hurd-amd64
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libluajit-5.1-common (= ${source:Version}),
@@ -61,7 +60,7 @@
 Section: libdevel
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64
+Architecture: amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64 hurd-i386 hurd-amd64
 Depends: libluajit-5.1-2 (= ${binary:Version}),
          ${misc:Depends},
 Conflicts: libluajit2-5.1-dev

=== debian/rules ===
#!/usr/bin/make -f
ABIM:=$(shell grep MAJVER Makefile|cut -d = -f 2|tr -d ' ')
ABIN:=$(shell grep MINVER Makefile|cut -d = -f 2|tr -d ' ')
ABIO:=$(shell grep RELVER Makefile|cut -d = -f 2|tr -d ' ')
ABI=$(ABIM).$(ABIN).$(ABIO)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
include /usr/share/dpkg/default.mk

DEB_CFLAGS_MAINT_APPEND := -DLUAJIT_ENABLE_LUA52COMPAT

%:
	dh $@

override_dh_auto_build:
	$(MAKE) amalg PREFIX=/usr \
		MULTILIB=lib/$(DEB_HOST_MULTIARCH) \
		CROSS=$(DEB_HOST_GNU_TYPE)- \
		Q= E=@:

override_dh_auto_install:
	make install PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp/ \
		MULTILIB=lib/$(DEB_HOST_MULTIARCH) LDCONFIG="/sbin/ldconfig -n"
	sed -i 's?^multilib=.*?multilib=lib/$(DEB_HOST_MULTIARCH)?' \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*.pc
	# debian doesn't allow multiple luajit versions, just rename the binary to luajit
	mv $(CURDIR)/debian/tmp/usr/bin/luajit-* $(CURDIR)/debian/tmp/usr/bin/luajit

execute_after_dh_auto_test:
	# fail early on architectures it does not support
	./src/luajit -e 'print(true)'
